// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//
// Copyright (C) 1998  Dialogic Corporation.  All Rights Reserved.
//
// This is a header for the device-specific extensions common to Dialogic and other TAPI service
// providers. Each service provider specific-header file should include this header file.
// The application typically should not include this header directly, because it will always 
// include the service provider-specific header.

#ifndef DEVSPEC_INCLUDED
#define DEVSPEC_INCLUDED	1

//
// Common device specific commands
//
#define DEVSPEC_COMMON		0x00010000
#define SC_LISTEN			(DEVSPEC_COMMON + 1)	// Set SC-bus receive time slot.


typedef struct _dxxxDevSpec
{
	DWORD dwCode;
	DWORD dwRecTime;
	BYTE pbData[1];
} DXXXDEVSPEC, *PDXXXDEVSPEC;


// SC-bus routing area
#define NETWORK_TSP	0x00000001
#define VOICE_TSP	0x00000002


//
// Time slot listen command (SC_LISTEN) structure.
// Used to specify SC-Bus receive time slot to be used by specified line.
// This struct is appended to the DXXXDEVSPEC header at pbData.
//
typedef struct _scbuslisten
{
	DWORD dwChannelType;	// voice or network
	long lTxSlot;			// new tslot to listen to
} SCBUSLISTEN, *PSCBUSLISTEN;


//
// Device specific structure which returns time slot assignments,
// obtained by calling TSPI_lineGetDevCaps().
// This structure is appended to the LINEDEVCAPS structure using
// dwDevSpecificSize and dwDevSpecificOffset parameters.
//
typedef struct _scbusinfo
{
	LONG		lVTxSlot;		// transmit timeslot for voice channel
	LONG		lVRxSlot;		// receive timeslot for voice channel
	LONG		lNTxSlot;		// transmit timeslot for network channel
	LONG		lNRxSlot;		// receive timeslot for network channel
} SCBUSINFO, *PSCBUSINFO;

typedef struct _trunkdata
{
   DWORD    dwAlarmOn;
   DWORD    dwAlarmType;
} TRUNKDATA, *PTRUNKDATA;


#endif
