/***********************************************************************
 *        FILE: srl_eblk.h
 * DESCRIPTION: Header File for DIALOGIC Windows NT library
 *
 *   Copyright (c) Dialogic Corp. All Rights Reserved
 *
 *   THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Dialogic Corp.
 *   The copyright notice above does not evidence any actual or
 *   intended publication of such source code.
 ***********************************************************************/


#ifndef __SRL_EBLK_H__
#define __SRL_EBLK_H__


/*
 * EV_EBLK
 *
 * Event Block Structure - if 8 bytes or less of event-specific data, it
 * is stored in ev_data and ev_datap is NULL.  Otherwise ev_datap points to
 * malloc'd memory and ev_data is unused.  In either case, ev_len specifies
 * the number of bytes of event-specific data present.
 */
typedef struct ev_eblk {
   long           ev_dev;     /* Device on which event occurred    */
   unsigned long  ev_event;   /* Event that occured                */
   long           ev_len;     /* # of bytes of event-specific data */
   unsigned char  ev_data[8]; /* Event-specific data               */
   void          *ev_datap;   /* Event-specific data pointer       */
} EV_EBLK;


#endif

