#ifndef _INC_NV_H
#define _INC_NV_H


// 6-24
#include <pshpack8.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef DLLIMPEXPORT
#define DLLIMPEXPORT __declspec( dllexport ) __stdcall
#endif

#define NVDLL_VERSION   (DWORD)0x00010007 /* v1.07 - 1st 16 bits is major version, 2nd 16 bits is minor version */

#include "nvapi.h"
#include "defs.h"


/////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _INC_DLL_PROTOTYPES
#define _INC_DLL_PROTOTRPES

//
// * NVDSP DLL function prototypes
//

// Unicode Definitions
#ifdef UNICODE
#define NVCallString NVCallStringW
#define NVCallStringEx NVCallStringExW
#define NVDialString NVDialStringW
#define NVDialStringEx NVDialStringExW
#define NVGetLastError      NVGetLastErrorW
#define NVGetLastErrorVal   NVGetLastErrorW( NULL, NULL, NULL )
#define NVPlayFile NVPlayFileW
#define NVPlayFileEx NVPlayFileExW
#define NVPlayIndex NVPlayIndexW
#define NVPlayIndexFiles NVPlayIndexFilesW
#define NVSendFax NVSendFaxW
#define NVRecvFax NVRecvFaxW
#define NVSendFaxEx NVSendFaxExW
#define NVRecvFaxEx NVRecvFaxExW
#define NVRecFile NVRecFileW
#define NVRecFileEx NVRecFileExW
#else
#define NVCallString NVCallStringA
#define NVCallStringEx NVCallStringExA
#define NVDialString NVDialStringA
#define NVDialStringEx NVDialStringExA
#define NVGetLastError      NVGetLastErrorA
#define NVGetLastErrorVal   NVGetLastErrorA( NULL, NULL, NULL )
#define NVPlayFile NVPlayFileA
#define NVPlayFileEx NVPlayFileExA
#define NVPlayIndex NVPlayIndexA
#define NVPlayIndexFiles NVPlayIndexFilesA
#define NVPlayIndexFilesEx NVPlayIndexFilesExA
#define NVSendFax NVSendFaxA
#define NVRecvFax NVRecvFaxA
#define NVSendFaxEx NVSendFaxExA
#define NVRecvFaxEx NVRecvFaxExA
#define NVRecFile NVRecFileA
#define NVRecFileEx NVRecFileExA
#endif /* !UNICODE */


// To get the input values for alert tone
NV_RESULT DLLIMPEXPORT
MTGetAlertTone(CHANNEL nChannel,MTALERT_TONE *alert_tone);

// To set the input values for alert tone
NV_RESULT DLLIMPEXPORT
MTSetAlertTone(CHANNEL nChannel,MTALERT_TONE *alert_tone);

// initialization Board Functions..
NV_RESULT DLLIMPEXPORT MTCreateFSKLinear(unsigned short *message,int fsk_length,unsigned char *fsk_output,int alerttone,int idle_time);
long DLLIMPEXPORT MTCalcFSKSize(int fsk_length, int alerttone,int idle_time);

NV_RESULT DLLIMPEXPORT
NVStopLink(
    VOID
    );

NV_RESULT DLLIMPEXPORT
NVStartLink(
    VOID
    );

NV_RESULT DLLIMPEXPORT
NVGetBusType(int *type);

// Station Functions...

NV_RESULT DLLIMPEXPORT
MTSM_ToneParams(
    USHORT				tone,
	MTSM_TONE			*toneParams
	);

NV_RESULT DLLIMPEXPORT
MTSM_Send(
    USHORT				nChannel,
	USHORT				tone
	);
NV_RESULT DLLIMPEXPORT
MTSM_StopSend(
    USHORT				nChannel,
	USHORT				tone
	);

NV_RESULT DLLIMPEXPORT
MTSM_Parameters(
	USHORT				nChannel,
    USHORT				parameter,
	USHORT				value
	);

NV_RESULT DLLIMPEXPORT
MTSM_Query(
	USHORT				nChannel,
	USHORT				*channel_type
	);

NV_RESULT DLLIMPEXPORT
NVChannelEnableDisable(
					   USHORT				nChannel,
					   USHORT				value
					   );


// Conferencing Functions...

NV_RESULT DLLIMPEXPORT
NVStartMUX(
    USHORT * chans
    );

NV_RESULT DLLIMPEXPORT
NVStopMUX(
    VOID
    );

NV_RESULT DLLIMPEXPORT
NVSplitAll(
    VOID
    );

NV_RESULT DLLIMPEXPORT
NVJoin(
    CHANNEL nChannel1,
    CHANNEL nChannel2
    );

NV_RESULT DLLIMPEXPORT
NVSplit(
    CHANNEL nChannel1,
    CHANNEL nChannel2
    );

NV_RESULT DLLIMPEXPORT
NVSetPoint(
    USHORT x,
    USHORT y
    );

NV_RESULT DLLIMPEXPORT
NVResetPoint(
    USHORT x,
    USHORT y
    );

//
// MVIP bus Routines
//
NV_RESULT DLLIMPEXPORT
NVSetRoute(
    CHANNEL			nChannel,
	USHORT			slot,
	UCHAR			direction
	);

NV_RESULT DLLIMPEXPORT
NVMVIPSwitch(
    CHANNEL			nChannel,
	USHORT			slot,
	UCHAR			direction
	);

NV_RESULT DLLIMPEXPORT
NVResetRoute(
    CHANNEL			nChannel,
	USHORT			slot,
	UCHAR			direction
	);

NV_RESULT DLLIMPEXPORT
MTRoute(
    USHORT			src,
	USHORT			src_index,
	USHORT			dest,
	USHORT			dest_index,
	USHORT			mode,
	USHORT			dir	
	);

// Group Functions..
NV_RESULT DLLIMPEXPORT
NVOpenGroup(
    HGROUP * group
    );
NV_RESULT DLLIMPEXPORT
NVEnterGroup(
    HGROUP group,
    CHANNEL nChannel,
    USHORT dir
    );

NV_RESULT DLLIMPEXPORT
NVLeaveGroup(
    HGROUP group,
    CHANNEL nChannel
    );
NV_RESULT DLLIMPEXPORT
NVHoldGroup(
    HGROUP group
    );
NV_RESULT DLLIMPEXPORT
NVUnholdGroup(
    HGROUP group
    );
NV_RESULT DLLIMPEXPORT
NVCloseGroup(
    HGROUP group
    );
NV_RESULT DLLIMPEXPORT
NVGetGroup(
    HGROUP group,
    ULONG * pList
    );
NV_RESULT DLLIMPEXPORT
NVResetGroup(
    HGROUP group
    );
NV_RESULT DLLIMPEXPORT
NVSetGroup(
    HGROUP group,
    ULONG * pList
    );
NV_RESULT DLLIMPEXPORT
NVStatusGroup(
    HGROUP group,
    PGROUP_STATUS pGroup_status
    );

// Async Functions..
NV_RESULT DLLIMPEXPORT
NVWink(
    CHANNEL nChannel,
    PNV_IO_CONTROL  pIoCtlVals  /* copied, may be null if an event queue */
    );                          /* is associated with the channel */

NV_RESULT DLLIMPEXPORT
NVWinkEx(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVOnHook(
    CHANNEL nChannel,
    PNV_IO_CONTROL  pIoCtlVals		// Should be be null 
	);

NV_RESULT DLLIMPEXPORT
NVOnHookEx(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVOffHook(
    CHANNEL nChannel,
    PNV_IO_CONTROL  pIoCtlVals		// Should be NULL
	);

NV_RESULT DLLIMPEXPORT
NVOffHookEx(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVDialStringA(
    CHANNEL nChannel,
    PCSTR pDial_string,
    PNV_IO_CONTROL pIoCtlDefs  /* Should be null */
    );

NV_RESULT DLLIMPEXPORT
NVDialStringW(
    CHANNEL nChannel,
    PCWSTR pDial_string,
    PNV_IO_CONTROL pIoCtlDefs  /* Should be null */
    );


NV_RESULT DLLIMPEXPORT
NVDialStringExA(
    CHANNEL nChannel,
    PCSTR pDial_string,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVDialStringExW(
    CHANNEL nChannel,
    PCWSTR pDial_string,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVStopChannel(
    CHANNEL nChannel
    );

NV_RESULT DLLIMPEXPORT
NVStopCh(
    CHANNEL nChannel,
	USHORT	mode
    );

NV_RESULT DLLIMPEXPORT
NVReadDigit(
    CHANNEL nChannel,
    UCHAR * pDigit
    );

NV_RESULT DLLIMPEXPORT
NVClearDigits(
    CHANNEL nChannel
    );

// General Streaming Functions..
  NV_RESULT DLLIMPEXPORT
	NVStreamBufStop(
    CHANNEL nChannel,
	USHORT	mode
    );
// General Streaming Functions..


// asynchronous  streaming
NV_RESULT DLLIMPEXPORT
NVStreamBufStartEx(
    CHANNEL nChannel,
	USHORT	action,
    USHORT  format,
	USHORT	mode
    );
NV_RESULT DLLIMPEXPORT
NVStreamBufInEx(
    CHANNEL nChannel,
	LONG	timeOut,
	PUCHAR	Buf,
	ULONG	BufSize,
    LPOVERLAPPED pOverlapped
    );
NV_RESULT DLLIMPEXPORT
NVStreamBufOutEx(
    CHANNEL nChannel,
	LONG	timeOut,
	PUCHAR	Buf,
	ULONG	BufSize,
    LPOVERLAPPED pOverlapped
    );

// asynchronous  streaming

// synchronous  streaming
NV_RESULT DLLIMPEXPORT
NVStreamBufStart(
    CHANNEL nChannel,
	USHORT	action,
    USHORT  format
    );

NV_RESULT DLLIMPEXPORT
NVStreamBufIn(
    CHANNEL nChannel,
	LONG	timeOut,
	PUCHAR	Buf,
	ULONG	BufSize
    );
NV_RESULT DLLIMPEXPORT
NVStreamBufOut(
    CHANNEL nChannel,
	LONG	timeOut,
	PUCHAR	Buf,
	ULONG	BufSize
    );

// synchronous  streaming


// Asynchronous streaming with termination events
NV_RESULT DLLIMPEXPORT
NVRecStreamBuffer(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIOCtl  /* copied, required */
    );

NV_RESULT DLLIMPEXPORT
NVRecStreamBufferEx(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIOCtl,
    LPOVERLAPPED pOverlapped
    );
NV_RESULT DLLIMPEXPORT
NVPlayStreamBuffer(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIOCtl  /* copied, required */
    );

NV_RESULT DLLIMPEXPORT
NVPlayStreamBufferEx(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIOCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVReadStreamBuffer(
    CHANNEL nChannel,
	LONG	timeOut,
	PUCHAR	Buf,
	ULONG	BufSize
    );

NV_RESULT DLLIMPEXPORT
NVReadStreamBufferEx(
    CHANNEL nChannel,
	LONG	timeOut,
	PUCHAR	Buf,
	ULONG	BufSize,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVWriteStreamBuffer(
    CHANNEL nChannel,
	LONG	timeOut,
	PUCHAR	Buf,
	ULONG	BufSize
    );

NV_RESULT DLLIMPEXPORT
NVWriteStreamBufferEx(
    CHANNEL nChannel,
	LONG	timeOut,
	PUCHAR	Buf,
	ULONG	BufSize,
    LPOVERLAPPED pOverlapped
    );
// Asynchronous streaming with termination events


// Sync  Functions - CallString

NV_RESULT DLLIMPEXPORT
NVCallStringA(
    CHANNEL nChannel,
    PCSTR pCall_string,
    PNV_IO_CONTROL pIoCtlDefs  /* copied, may be null */
    );

NV_RESULT DLLIMPEXPORT
NVCallStringW(
    CHANNEL nChannel,
    PCWSTR pCall_string,
    PNV_IO_CONTROL pIoCtlDefs  /* copied, may be null */
    );


NV_RESULT DLLIMPEXPORT
NVCallStringExA(
    CHANNEL nChannel,
    PCSTR pCall_string,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVCallStringExW(
    CHANNEL nChannel,
    PCWSTR pCall_string,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );

// Sync  Functions  -Play /Record Functions..

NV_RESULT DLLIMPEXPORT
NVPlayBuffer(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIOCtl			//  required 
    );

NV_RESULT DLLIMPEXPORT
NVPlayBufferEx(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIOCtl,
    LPOVERLAPPED pOverlapped
    );


NV_RESULT DLLIMPEXPORT
NVPlayF(
    CHANNEL nChannel,
    HANDLE  fHandle,
    PNV_IO_CONTROL pIoCtl			// required , may be null
	);

NV_RESULT DLLIMPEXPORT
NVPlayFEx(
    CHANNEL nChannel,
    HANDLE  fHandle,
    PNV_IO_CONTROL pIoCtl,			// required , may be null
    LPOVERLAPPED pOverlapped
	);

NV_RESULT DLLIMPEXPORT
NVPlayFileA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PNV_IO_CONTROL pIoCtlVals		// required, may be null
    );                         

NV_RESULT DLLIMPEXPORT
NVPlayFileW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PNV_IO_CONTROL pIoCtlVals		// required , may be null
    );                         


NV_RESULT DLLIMPEXPORT
NVPlayFileExA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PNV_IO_CONTROL pIoCtlVals, /* Buffer must point to a fully-qualified   */
    LPOVERLAPPED pOverlapped   /*   wide-char file name (for Length bytes) */
    );

NV_RESULT DLLIMPEXPORT
NVPlayFileExW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PNV_IO_CONTROL pIoCtlVals, /* Buffer must point to a fully-qualified   */
    LPOVERLAPPED pOverlapped   /*   wide-char file name (for Length bytes) */
    );
NV_RESULT DLLIMPEXPORT
NVRecFileA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PNV_IO_CONTROL pIOCtl  
    );                     

NV_RESULT DLLIMPEXPORT
NVRecFileW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PNV_IO_CONTROL pIOCtl  
    );                     


NV_RESULT DLLIMPEXPORT
NVRecFileExA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PNV_IO_CONTROL pIOCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVRecFileExW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PNV_IO_CONTROL pIOCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVRecBuffer(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIOCtl  /* copied, required */
    );

NV_RESULT DLLIMPEXPORT
NVRecBufferEx(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIOCtl,
    LPOVERLAPPED pOverlapped
    );


NV_RESULT DLLIMPEXPORT
NVPlayIndexA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PCNV_INDEX_TABLE pIxTable,
    PNV_IO_CONTROL pIoCtlVals  /* copied, may be null if an event queue */
    );                         /* is associate with the channel */

NV_RESULT DLLIMPEXPORT
NVPlayIndexW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PCNV_INDEX_TABLE pIxTable,
    PNV_IO_CONTROL pIoCtlVals  /* copied, may be null if an event queue */
    );                         /* is associate with the channel */

NV_RESULT DLLIMPEXPORT
NVPlayIndexFilesA(
    CHANNEL nChannel,
    PCNV_FINDEX_TABLEA pFIxTable,
    PNV_IO_CONTROL pIoCtl /* copied, null ok if evt queue assoc w/channel */
    );

NV_RESULT DLLIMPEXPORT
NVPlayIndexFilesW(
    CHANNEL nChannel,
    PCNV_FINDEX_TABLEW pFIxTable,
    PNV_IO_CONTROL pIoCtl /* copied, null ok if evt queue assoc w/channel */
    );

NV_RESULT DLLIMPEXPORT
NVPlayIndexFilesExA(
    CHANNEL nChannel,
    PCNV_FINDEX_TABLEA pFIxTable,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVPlayIndexFilesExW(
    CHANNEL nChannel,
    PCNV_FINDEX_TABLEW pFIxTable,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );


// Other Sync Functions..
NV_RESULT DLLIMPEXPORT
NVGetDigits(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIoCtl  /* required */
    );

NV_RESULT DLLIMPEXPORT
NVGetDigitsEx(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );


// Tone Functions....
 NV_RESULT DLLIMPEXPORT
NVGetUsrTone(
    CHANNEL				nChannel,
	UCHAR				index,
	PUCHAR				digit,
	PUCHAR				type,
	PUCHAR				mask,
	PNV_CPMTONE			cpm
	);

NV_RESULT DLLIMPEXPORT
NVPlayUsrToneEx(
    CHANNEL				nChannel,
    PNV_IO_CONTROL		pIoCtl,
    LPOVERLAPPED		pOverlapped
    );

NV_RESULT DLLIMPEXPORT
NVPlayUsrTone(
    CHANNEL				nChannel,
    PNV_IO_CONTROL		pIoCtl
    );

NV_RESULT DLLIMPEXPORT
NVClearUsrTone(
    CHANNEL		nChannel
	);

NV_RESULT DLLIMPEXPORT
NVSetUsrTone(
    CHANNEL				nChannel,
	UCHAR				dig,
	UCHAR				type,
	NV_USRTONE			*tone
	);

NV_RESULT DLLIMPEXPORT
NVSetUsrToneMode(
    CHANNEL				nChannel,
	USHORT				tone_id,
	UCHAR				mode
	);

//
// CPM Tone Functions
//
NV_RESULT DLLIMPEXPORT
NVGetCpmTone(
    CHANNEL		nChannel,
	UCHAR		index,
	PNV_CPMTONE	cpm
	);

NV_RESULT DLLIMPEXPORT
NVSetCpmTone(
    CHANNEL		nChannel,
	PNV_CPMTONE	cpm
	);

NV_RESULT DLLIMPEXPORT
NVResetCpmTone(
    CHANNEL				nChannel,
	UCHAR				mode
	);

NV_RESULT DLLIMPEXPORT
NVSetCpmToneMode(
    CHANNEL				nChannel,
	UCHAR				mode
	);

// Fax Functions..

// FAX capability Support from driver version V1.12
NV_RESULT DLLIMPEXPORT
NVSendFaxA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PNVFAX_IO_CONTROL pFAXIoCtl      
    );       

NV_RESULT DLLIMPEXPORT
NVSendFaxW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PNVFAX_IO_CONTROL pFAXIoCtl      
    );   

NV_RESULT DLLIMPEXPORT
NVSendFaxExA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PNVFAX_IO_CONTROL pFAXIoCtl,      
    LPOVERLAPPED pOverlapped	
    );

NV_RESULT DLLIMPEXPORT
NVSendFaxExW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PNVFAX_IO_CONTROL pFAXIoCtl,      
    LPOVERLAPPED pOverlapped	
    );         

NV_RESULT DLLIMPEXPORT
NVRecvFaxA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PNVFAX_IO_CONTROL pFAXIoCtl      
    );       

NV_RESULT DLLIMPEXPORT
NVRecvFaxW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PNVFAX_IO_CONTROL pFAXIoCtl      
    );   

NV_RESULT DLLIMPEXPORT
NVRecvFaxExA(
    CHANNEL nChannel,
    PCSTR pFileName,
    PNVFAX_IO_CONTROL pFAXIoCtl,     
    LPOVERLAPPED pOverlapped	
    );

NV_RESULT DLLIMPEXPORT
NVRecvFaxExW(
    CHANNEL nChannel,
    PCWSTR pFileName,
    PNVFAX_IO_CONTROL pFAXIoCtl,      
    LPOVERLAPPED pOverlapped	
    );  

NV_RESULT DLLIMPEXPORT
NVFaxGetParam(
    CHANNEL		nChannel,
	USHORT		paramName,
    UCHAR		*pBuf
    );

NV_RESULT DLLIMPEXPORT
NVFaxSetParam(
    CHANNEL		nChannel,
	USHORT		paramName,
    UCHAR		*pBuf
    );


NV_RESULT DLLIMPEXPORT
NVFaxGetChInfo(
    CHANNEL		nChannel,
    NVFAX_INFO	*ChanInfo
    );

NV_RESULT DLLIMPEXPORT
NVFaxSetChInfo(
    CHANNEL		nChannel,
    NVFAX_INFO	*ChanInfo
    );

NV_RESULT DLLIMPEXPORT
NVFaxGetStatus(
    CHANNEL		nChannel,
    USHORT		request,
	USHORT		*value
    );

// Version Functions..
DWORD DLLIMPEXPORT
NVGetDLLVersion(
    VOID
    );

NV_RESULT DLLIMPEXPORT
NVGetVersion(
    USHORT * pDriverVersion,			// Driver version
    USHORT * pBaseBoardVersion,         // DSP firmware version 
    USHORT * pBaseTIVersion             // Obsolete
    );

NV_RESULT DLLIMPEXPORT NVGetVersionEx
( 
	char *pDriverVersion, int lenDriverVersion,
	char *pFirmwareVersion ,int lenFirmwareVersion
) ;

// Board Functions

NV_RESULT DLLIMPEXPORT
NVCheckLink(
    PLINK_INFO pInfo
    );
NV_RESULT DLLIMPEXPORT
NVGetBoardInfo(
    BOARD nBoard,
    PBOARD_INFO pBoard_info
    );

NV_RESULT DLLIMPEXPORT
NVGetOEMInfo(
    BOARD board,
    POEM_INFO pOem_info    );

NV_RESULT DLLIMPEXPORT 
NVGetSerialNumber
( 
	BOARD board,	
    char *pSerialNumber, int len	
);
// Events Functions..
NV_RESULT DLLIMPEXPORT
NVWaitForVoiceEvent(
    CHANNEL nChannel,
    DWORD dwTimeoutMs,
    PNVDSP_EVENT pNVXEvent  /* may be null */
    );

NV_RESULT DLLIMPEXPORT
NVGetEvent(
    DWORD dwTimeoutMs,
    PNVDSP_EVENT pNVXEvent  /* may be null */
    );

NV_RESULT DLLIMPEXPORT
NVPutEvent(
    CHANNEL nChannel,
    PNVDSP_EVENT pNVXEvent  /* may be null */
    );

NV_RESULT DLLIMPEXPORT
NVSetEvents(
    CHANNEL nChannel,
    USHORT eventMask,
    USHORT nRings
    );

NV_RESULT DLLIMPEXPORT
NVSetMoni(
    CHANNEL nChannel,
    USHORT mask
    );

NV_RESULT DLLIMPEXPORT
NVSetTerm(
    CHANNEL nChannel,
    USHORT mask
    );

NV_RESULT DLLIMPEXPORT
NVEventControl(
    USHORT action
    );

NV_RESULT DLLIMPEXPORT
NVFlushEvents(
    CHANNEL nChannel
    );

long DLLIMPEXPORT
NVGetLastTerm(
    CHANNEL nChannel
    );

// Error Functions..
NV_RESULT DLLIMPEXPORT
NVGetLastErrorA(
    PNV_RESULT pExtError,
    PUSHORT nErrBufSize,
    PSTR pErrBuf
    );

NV_RESULT DLLIMPEXPORT
NVGetLastErrorW(
    PNV_RESULT pExtError,
    PUSHORT nErrBufSize,
    PWSTR pErrBuf
    );


 //Structure Functionss
NV_RESULT DLLIMPEXPORT
NVGetCallResult(
    CHANNEL nChannel,
    PCALL_RESULT pCall_result
    );


NV_RESULT DLLIMPEXPORT
NVGetStatus(
    CHANNEL nChannel,
    PCHAN_STATUS pChan_status
    );

NV_RESULT DLLIMPEXPORT
NVSetDefCPM(
    CHANNEL nChannel,
    ULONG mode
    );


NV_RESULT DLLIMPEXPORT
NVSetGain(
    CHANNEL nChannel,
    SHORT gain
    );

NV_RESULT DLLIMPEXPORT
NVSetParam(
    CHANNEL nChannel,
    USHORT id,
    USHORT value
    );

NV_RESULT DLLIMPEXPORT
NVStepGain(
    CHANNEL nChannel,
    SHORT step
    );


NV_RESULT DLLIMPEXPORT
NVxCPM(
    CHANNEL nChannel,
    PNV_IO_CONTROL  pIoCtlVals  /* copied, may be null if an event queue */
    );                          /* is associated with the channel */

NV_RESULT DLLIMPEXPORT
NVxCPMEx(
    CHANNEL nChannel,
    PNV_IO_CONTROL pIoCtl,
    LPOVERLAPPED pOverlapped
    );

//
// Volume Functions
//
NV_RESULT DLLIMPEXPORT
NVSetVolume(
    CHANNEL			nChannel,
	SHORT			volume
	);

NV_RESULT DLLIMPEXPORT
NVStepVolume(
    CHANNEL			nChannel,
	USHORT			step
	);

NV_RESULT DLLIMPEXPORT
NVSetPSTN(
    CHANNEL			nChannel,
	PNV_PSTNREGS	regs
	);

NV_RESULT DLLIMPEXPORT
NVGetPSTN(
    CHANNEL			nChannel,
	PNV_PSTNREGS	regs
	);

NV_RESULT DLLIMPEXPORT
NVSetGenRegs(
    CHANNEL		nChannel,
	UCHAR		type,
	PNV_GENREGS	regs
	);

NV_RESULT DLLIMPEXPORT
NVGetGenRegs(
    CHANNEL		nChannel,
	UCHAR		type,
	PNV_GENREGS	regs
	);

NV_RESULT DLLIMPEXPORT
NVSetDetectRegs(
    CHANNEL			nChannel,
	UCHAR			type,
	PNV_DETECTREGS	regs
	);

NV_RESULT DLLIMPEXPORT
NVGetDetectRegs(
    CHANNEL			nChannel,
	UCHAR			type,
	PNV_DETECTREGS	regs
	);

NV_RESULT DLLIMPEXPORT
NVSetACTDRegs(
    CHANNEL			nChannel,
	PNV_ACTPARAMS	pAct_params
	);

NV_RESULT DLLIMPEXPORT
NVGetACTDRegs(
    CHANNEL			nChannel,
	PNV_ACTPARAMS	pAct_params
	);

NV_RESULT DLLIMPEXPORT
NVSetPxdRegs(
    CHANNEL		nChannel,
	PNV_PSTNPXD	regs
	);

NV_RESULT DLLIMPEXPORT
NVSetPxdEcho(
    CHANNEL		nChannel,
	USHORT		value
	);


NV_RESULT DLLIMPEXPORT
NVGetPxdRegs(
    CHANNEL		nChannel,
	PNV_PSTNPXD	regs
	);


int	
NVEnbHdlr(
	int		chan, 
	int		eventType,
	PVOID	Callback);

int	NVDisHdlr(
	int chan, 
	int eventType
	);

VOID
NVEvtMgrStart(VOID);

VOID
NVEvtMgrStop(VOID);

VOID NVSetEventWnd(HWND hEventWnd,UINT	MsgID);

VOID NVResetEventWnd(HWND hEventWnd);

// other Functions ,,,
NV_RESULT DLLIMPEXPORT
NVControlDigits(
    CHANNEL nChannel,
    ULONG dtmfEnableMask,
    ULONG queueControl
    );

// Obsolete
NV_RESULT DLLIMPEXPORT
NVGetMuxmatrix(
    LPBYTE matrix
    );

// Not support yet
NV_RESULT DLLIMPEXPORT
NVPlayIndexHandle(
    CHANNEL nChannel,
    PCNV_INDEX_TABLE pIxTable,
    PNV_IO_CONTROL pIoCtl      /* copied, may be null if an event queue */
    );                         /* is associate with the channel */


#endif //#ifndef _INC_DLL_PROTOTYPES

/////////////////////////////////////////////////////////////////////////////////////////////
#ifdef __cplusplus
} /* end extern "C" */
#endif

// 6-24
#include <poppack.h>
#endif /* _INC_NV_H */
