#ifndef BRD_SIMULATOR_COMMUNICATION_H
#define BRD_SIMULATOR_COMMUNICATION_H

#include "board_communication.h"

class BoardSimulatorCommunicationPacket : public BoardCommunicationPacket
{
   public:

      // Events sent to a thread from the service.
      enum BRD_SIMULATOR_EVENT
      {
         BRD_SIMULATOR_RING,
         BRD_SIMULATOR_DIGIT,
         BRD_SIMULATOR_ON_HOOK,
         BRD_SIMULATOR_OFF_HOOK,
         BRD_SIMULATOR_CED,
         BRD_SIMULATOR_SIT,
         BRD_SIMULATOR_BUSY,
         BRD_SIMULATOR_NO_ANSWER,
         BRD_SIMULATOR_PLAYRECORD_DONE,
         BRD_SIMULATOR_INTERRUPTPLAYRECORD,
         BRD_SIMULATOR_CHANGE_SHORT_AUDIO_LENGTH,
         BRD_SIMULATOR_BARGEIN,
         BRD_SIMULATOR_AUDIO_CHUNK_FINISHED
      };

      BoardSimulatorCommunicationPacket(BRD_SIMULATOR_EVENT event);

      const char* GetEventName(void);
      static const char* GetEventName(BoardSimulatorCommunicationPacket::BRD_SIMULATOR_EVENT event);

      BRD_SIMULATOR_EVENT event;
      int eventInfo;
};

#endif
