#ifndef LOADLANGUAGE_H
#define LOADLANGUAGE_H

#include "..\TFServer\ivrinfo.h"

// Loads a language module DLL, creates a Voice object, and updates pInfo appropriately.
bool LoadLanguageModule(PIVRINFO pInfo, const char* languageDLL);

// Assigns the creation and destruction functions for use by LoadLanguageModule
// and UnloadLanguageModule from the language module DLL specified by handle languageLibrary.
// If unsuccessful, neither LoadLanguageModule or UnloadLanguageModule will be
// effective, and LoadLanguageModuleFunctions will return false.
bool LoadLanguageModuleFunctions(HINSTANCE languageLibrary);

// Destroys the LanguageModule object in pInfo, unloads the language module DLL,
// and updates pInfo appropriately
void UnloadLanguageModule(PIVRINFO pInfo);

#endif
