#include <stdlib.h>          // Needed for "system".
#include "step_appexec.h"

StepAppExec::StepAppExec(STEPREC& stepRecord) : Step(stepRecord)
{
   cmd = stepRecord.s6.arr;
   varName = stepRecord.s1.arr;
}

StepAppExec::~StepAppExec(void)
{
}

const char* StepAppExec::GetStepName(void) const
{
	return("Run Program");
}

IV_STATUS StepAppExec::Execute(PIVRINFO pInfo)
{
   char* value;
   IV_STATUS status = IVR_SUCCESS;
   int rslt;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Command", cmd.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   rslt = system(value);
   delete[] value;

   if(!varName.empty())
   {
      value = new char[10];
      sprintf(value, "%d", rslt);
      status = pInfo->variables->Set(varName.c_str(), value) ? IVR_SUCCESS : IVR_FATAL;
      delete[] value;
   }

   return(status);
}
