#include "step_audiodelete.h"
#include "..\BoardDLLs\brd_generic.h"

StepAudioDelete::StepAudioDelete(STEPREC& stepRecord) : Step(stepRecord)
{
   fileNm = stepRecord.s6.arr;
}

StepAudioDelete::~StepAudioDelete(void)
{
}

const char* StepAudioDelete::GetStepName(void) const
{
	return("Delete File");
}

IV_STATUS StepAudioDelete::Execute(PIVRINFO pInfo)
{
   IV_STATUS status;
   char* value;
   char* pathName;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("File name", fileNm.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   pathName = pInfo->variables->FilePath(value);
   delete[] value;

   pInfo->ivLog->Print("      Deleting '%s'\n", pathName);

   status = pInfo->ivBoard->AudioDelete(pathName);
   delete[] pathName;

   return(status);
}
