#include "step_faxclear.h"
#include "..\BoardDLLs\brd_generic.h"

StepFaxClear::StepFaxClear(STEPREC& stepRecord) : Step(stepRecord)
{
}

StepFaxClear::~StepFaxClear(void)
{
}

const char* StepFaxClear::GetStepName(void) const
{
	return("Fax Clear");
}

IV_STATUS StepFaxClear::Execute (PIVRINFO pInfo)
{
   IV_STATUS  status;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

	if(PortRequired(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FATAL);
   }

   if((status = pInfo->ivBoard->FaxQueueClr()) == IVR_NOTSUPPORTED)
   {
	   pInfo->ivLog->Print("      Faxing option not installed.\n");
   }

   return(status);
}
