#include "step_setglobal.h"

StepSetGlobal::StepSetGlobal(STEPREC& stepRecord) : Step(stepRecord)
{
   switch(stepRecord.u1)
   {
      case 1: iType = GLOBAL_HANGUP; break;
      case 2:
      default:  iType = GLOBAL_FATAL;
   }
   label = stepRecord.s2.arr;
}

StepSetGlobal::~StepSetGlobal(void)
{
}

const char* StepSetGlobal::GetStepName(void) const
{
	return("Global Event");
}

IV_STATUS StepSetGlobal::Execute(PIVRINFO pInfo)
{
   IV_STATUS  status;
	char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->ParseParameter("Label", label.c_str())) == NULL)
   {
      return(IVR_FATAL);
   }

   switch(iType)
   {
      case GLOBAL_HANGUP:
      {
         status = pInfo->variables->SetSystem("@HANGUP", value) ? IVR_SUCCESS : IVR_FATAL;
         break;
      }

      case GLOBAL_FATAL:
      {
         status = pInfo->variables->SetSystem("@FATAL", value) ? IVR_SUCCESS : IVR_FATAL;
         break;
      }

      default:
      {
         pInfo->ivLog->Print("      ERROR: Global Event value %d out of range\n", iType);
         status = IVR_FATAL;
      }
   }

   delete[] value;

   return(status);
}
