#include "step_varset.h"
#include "..\BoardDLLs\brd_generic.h"

StepVarSet::StepVarSet(STEPREC& stepRecord) : Step(stepRecord)
{
   varNm = stepRecord.s1.arr;
   varValue = stepRecord.s6.arr;
}

StepVarSet::~StepVarSet(void)
{
}

const char* StepVarSet::GetStepName(void) const
{
	return("Set Global Variable");
}

IV_STATUS StepVarSet::Execute(PIVRINFO pInfo)
{
   IV_STATUS status;
   char* value;

   if(Status(pInfo) != IVR_SUCCESS)
   {
      return(IVR_FAIL);
   }

   if((value = pInfo->variables->Parse(varValue.c_str())) == NULL)
   {
      pInfo->ivLog->Print("      ERROR: Value '%s' is undefined\n", varValue.c_str());
      return(IVR_FATAL);
   }

   status = pInfo->variables->SetGlobal(varNm.c_str(), value) ? IVR_SUCCESS : IVR_FATAL;

   delete[] value;

   return(status);
}
