#ifndef STEP_VOCPASSREG_H
#define STEP_VOCPASSREG_H

#include "step.h"

class StepVocPassReg : public Step
{
   public:

      StepVocPassReg(STEPREC& stepRecord);
      virtual ~StepVocPassReg(void);

		const char* GetStepName(void) const;

      IV_STATUS Execute(PIVRINFO pInfo);

   protected:

      string userID;                 // s1 : User ID
		string playFile1;              // s2 : Audio to prompt for 1st password utterance
		string playFile2;              // s3 : Audio to prompt for 2nd password utterance
		string playFile3;              // s4 : Audio to prompt for 3rd password utterance
      string regPercent;             // s5 : Registration tolerance percentage
      string maxTime;						// s6 : Max record time in milliseconds.
      bool disableBeep;          		// u1 : disable beep (0 = beep enabled, 1 = beep disabled)
};

#endif
