#include "brd_load.h"
#include "..\escutil\odbc_db.h"
#include "..\xmlutil\xmllist.h"
#include "TFEngine_communication_manager.h"
#include "..\TFEngine\vce_list.h"
#include "TFApplication.h"

TFApplication::TFApplication(int appID, GUILog* ivLog)
{
   memset(&info, 0, sizeof(IVRINFO));
   info.iAppID = appID;
   info.portLicense = UNLICENSED;
   // 3 second application restart delay
   info.restartDelay = 3000;
   info.ivLog = ivLog;
   info.messages = new TFEngineCommunicationDestination(appID);
   info.variables = new VarController(&info);
   info.voiceList = new VoiceList;
   info.odbcManager = new ODBCManager(info.ivLog);
   info.xmlList = new XMLList(info.ivLog);
   info.bRestart = true;
   info.bTerminate = false;
   info.reloadRequested = false;
   info.shutdownRequested = false;
   info.safeToShutdown = true;
   info.status = lsEmpty;
}

TFApplication::~TFApplication(void)
{
   delete info.xmlList;
   delete info.odbcManager;
   delete info.voiceList;
   delete info.variables;
   if((ReleaseInstance != NULL) && (info.ivBoard != NULL))
   {
      ReleaseInstance(info.ivBoard);
   }
   delete info.messages;
   delete[] info.pszAppNm;
   delete[] info.pszAppFile;
   delete[] info.pszProtocol;
   for(int index = 0; index < info.iParamCount; index++)
   {
      delete[] info.pszParams[index];
   }
   delete[] info.pszLogDir;
   delete[] info.pszInstallationPath;
   delete info.ivLog;
}

