#ifndef TFSERVER_COMMUNICATION_H
#define TFSERVER_COMMUNICATION_H

#include "communication_hub.h"

class TFServerCommunicationPacket : public CommunicationPacket
{
   public:

      enum TF_DESTINATION_ID
      {
         TF_SERVER,
         TF_ENGINE_MANAGER,
         TF_TCPCLIENT_MANAGER,
         TF_SIMULATOR
      };

      // Events sent from a thread to the service.
      enum TF_SERVER_EVENT
      {
         SRV_EVT_ENG_THRD_DONE,     // If service still running, restart thread.
         SRV_EVT_MON_THRD_DONE,
         SRV_EVT_ENG_FATAL_ERROR,   // Remove thread from list, don't restart.
         SRV_EVT_MON_FATAL_ERROR,
         SRV_EVT_ENG_TERMINATED,    // Remove thread from list, don't restart.
         SRV_EVT_MON_TERMINATED,
         SRV_EVT_RELOAD_TAL
      };

      TFServerCommunicationPacket(TF_SERVER_EVENT event, int appID);

      TF_SERVER_EVENT event;
      int appID;
};

// Note that messages must be TFServerCommunicationPackets
// Messages for the server must use TF_SERVER as their destination
class TFServerCommunicationDestination : public CommunicationDestination<TFServerCommunicationPacket::TF_DESTINATION_ID>
{
   public:

      TFServerCommunicationDestination(void);

      TFServerCommunicationPacket::TF_DESTINATION_ID ID(void);
};

#endif
