#include "TFSimulator_communication.h"

TFSimulatorCommunicationPacket::TFSimulatorCommunicationPacket(TF_SIMULATOR_EVENT event, int appID)
   : event(event), appID(appID)

{
   stepName = NULL;
   TAMName = NULL;
   stepNumber = -1;
}

TFSimulatorCommunicationPacket::~TFSimulatorCommunicationPacket(void)
{
   delete[] stepName;
   delete[] TAMName;
}

const char* TFSimulatorCommunicationPacket::GetEventName(TFSimulatorCommunicationPacket::TF_SIMULATOR_EVENT event)
{
	switch(event)
   {
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_ON_HOOK: return("TF_SIMULATOR_ON_HOOK");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_OFF_HOOK: return("TF_SIMULATOR_OFF_HOOK");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_READY_FOR_CALL: return("TF_SIMULATOR_READY_FOR_CALL");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_NOT_READY_FOR_CALL: return("TF_SIMULATOR_NOT_READY_FOR_CALL");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_REFRESH: return("TF_SIMULATOR_REFRESH");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_OUTGOING_CALL: return("TF_SIMULATOR_OUTGOING_CALL");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_SET_HWI: return("TF_SIMULATOR_SET_HWI");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_SET_MCI_DEVICE: return("TF_SIMULATOR_SET_MCI_DEVICE");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_SHOW_STOP_RECORDING_BUTTON: return("TF_SIMULATOR_SHOW_STOP_RECORDING_BUTTON");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_HIDE_STOP_RECORDING_BUTTON: return("TF_SIMULATOR_HIDE_STOP_RECORDING_BUTTON");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_SHOW_BARGEIN_BUTTON: return("TF_SIMULATOR_SHOW_BARGEIN_BUTTON");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_HIDE_BARGEIN_BUTTON: return("TF_SIMULATOR_HIDE_BARGEIN_BUTTON");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_ENABLE_BARGEIN_BUTTON: return("TF_SIMULATOR_ENABLE_BARGEIN_BUTTON");
      case TFSimulatorCommunicationPacket::TF_SIMULATOR_DISABLE_BARGEIN_BUTTON: return("TF_SIMULATOR_DISABLE_BARGEIN_BUTTON");
      default: return("Unknown");
   }
}

const char* TFSimulatorCommunicationPacket::GetEventName(void)
{
   return(GetEventName(event));
}

TFSimulatorCommunicationDestination::TFSimulatorCommunicationDestination(void)
{
}

TFServerCommunicationPacket::TF_DESTINATION_ID TFSimulatorCommunicationDestination::ID(void)
{
   return(TFServerCommunicationPacket::TF_SIMULATOR);
}

