#ifndef LUMENVOXVOICE_H
#define LUMENVOXVOICE_H

#include "Voice.h"

namespace LumenVox
{
	#include "..\3rdparty\LumenVox\LVSpeechPort2.h"				// Version 4 of Lumenvox SRE
};

class LumenVoxVoice : public Voice
{
   public:
   
      // Constructor/Destructor
      LumenVoxVoice(unsigned int applid, Log* ivLog, BoardGeneric* board);
      ~LumenVoxVoice(void);

      IV_STATUS SRAcquire(const char* srResource, int telephonyPort, const char* pszAppName, const char* pszLogDir, bool logSRAudio);

      IV_STATUS SRAddGrammar(Voice::SR_GRAMMAR grammarType, const char* grammar);

      IV_STATUS SREnd(void);

      IV_STATUS SRGetResult(char* concept, unsigned int maxlength, unsigned int& confidence);

      IV_STATUS SRLoadGrammar(Voice::SR_GRAMMAR grammarType, const char* grammar);

      IV_STATUS SRRelease(void);

   protected:

      IV_STATUS ParseGrammarText(const char* text);

      LumenVox::LVSpeechPort m_pLVSP;
      int grammarSet;
};
      
#endif
