#ifndef FILE_FNS_H
#define FILE_FNS_H

#ifdef _MSC_VER
   #include <io.h>
   #include <direct.h>
   #define MAXPATH _MAX_PATH
   #define MAXDRIVE _MAX_DRIVE
   #define MAXDIR _MAX_DIR
   #define MAXFILE _MAX_FNAME
   #define MAXEXT _MAX_EXT
   #define ENOPATH ERROR_PATH_NOT_FOUND
   struct FindData
   {
      _finddata_t data;
      intptr_t handle;
   };
#else
   #include <dir.h>
   #define FindData ffblk
#endif

#if defined (__DLL__)
#define FILE_FNS_API __declspec(dllexport)
#else
#define FILE_FNS_API __declspec(dllimport)
#endif

FILE_FNS_API int ChangeDirectory(const char* path);
FILE_FNS_API bool DeleteTree(const char *pszPath);
FILE_FNS_API bool FileExists(const char *pszPath);
FILE_FNS_API int FindFirst(const char* path, FindData* findData);
FILE_FNS_API int FindNext(FindData* findData);
FILE_FNS_API char* GetName(FindData* findData);
FILE_FNS_API char* GetName(FindData* findData);
FILE_FNS_API void SplitPath(const char* path, char* drive, char* directory, char* name, char* extension);

#undef FILE_FNS_API

#endif
