/* -------------------------------------------------------------------------
   ------------------------------------------------------------------------- */
#ifndef INI_H
#define INI_H

#include <stdio.h>	// FILE

#define INI_MAX_LINE_SIZE 255

#if defined (__DLL__)
#define INIAPI __declspec(dllexport)
#else
#define INIAPI __declspec(dllimport)
#endif

enum STATUS { FAILURE, SUCCESS };

class INIAPI INIFile
{
   public:
      INIFile (const char *fileNm);
      ~INIFile();
      STATUS Open();
      STATUS Close();

      long FindFirst (const char *pszSection, char *pszParm, char *pszValue);
      long FindNext (char *pszParm, char *pszValue);
      long Find (const char *pzsSection, const char *pszParm, char *pszValue);
      STATUS GetPosition (long *offset);
      STATUS SetPosition (long offset);

   private:
      char *pszFileNm;
      FILE *fINI;
      bool  bInSection;

      void GetLine (char *pszLine);
      bool FindSection (const char *pszSection);
};

#undef INIAPI

#endif
